Properties Methods Events Config Options Direct Link

    Observable
      Tree

# Class Ext.data.Tree

Package: | Ext.data
Defined In: | Tree.js
Class: | Tree
Extends: | Observable

Represents a tree data structure and bubbles all the events for its nodes. The nodes in the tree have most standard DOM functionality.

## Config Options

Config Options | Defined By
--- | ---
| listeners : Object A config object containing one or more event handlers to be added to this object during initialization. This should b... A config object containing one or more event handlers to be added to this object during initialization. This should be a valid listeners config object as specified in the addListener example for attaching multiple handlers at once. | Observable
| pathSeparator : String The token used to separate paths in node ids (defaults to '/'). | Tree

## Public Properties

Property | Defined By
--- | ---
| root : Node The root node for this tree | Tree

## Public Methods

Method | Defined By
--- | ---

Tree( [`Node root`] )
Parameters:

- `root` : Node
  (optional) The root node

Returns:

- ``

Tree

addEvents( `Object object` ) : void
Used to define events on this Observable
Used to define events on this Observable
Parameters:

- `object` : Object
  The object with the events defined

Returns:

- `void`

Observable

addListener( `String eventName`, `Function handler`, [`Object scope`], [`Object options`] ) : void
Appends an event handler to this component
Appends an event handler to this component
Parameters:

- `eventName` : String
  The type of event to listen for
- `handler` : Function
  The method the event invokes
- `scope` : Object
  (optional) The scope in which to execute the handler function. The handler function's "this" context.
- `options` : Object
  (optional) An object containing handler configuration properties. This may contain any of the following properties:
  - scope : Object

    The scope in which to execute the handler function. The handler function's "this" context.

  - delay : Number

    The number of milliseconds to delay the invocation of the handler after the event fires.

  - single : Boolean

    True to add a handler to handle just the next firing of the event, and then remove itself.

  - buffer {Number} Causes the handler to be scheduled to run in an Ext.util.DelayedTask delayed by the specified number of milliseconds. If the event fires again within that time, the original handler is not invoked, but the new handler is scheduled in its place.

  Combining Options
  Using the options argument, it is possible to combine different types of listeners:
  A normalized, delayed, one-time listener that auto stops the event and passes a custom argument (forumId)

      el.on('click', this.onClick, this, {
          single: true,
          delay: 100,
          forumId: 4
      });

  Attaching multiple handlers in 1 call
  The method also allows for a single argument to be passed which is a config object containing properties which specify multiple handlers.

      foo.on({
          'click' : {
              fn: this.onClick,
              scope: this,
              delay: 100
          },
          'mouseover' : {
              fn: this.onMouseOver,
              scope: this
          },
          'mouseout' : {
              fn: this.onMouseOut,
              scope: this
          }
      });

  Or a shorthand syntax:

      foo.on({
          'click' : this.onClick,
          'mouseover' : this.onMouseOver,
          'mouseout' : this.onMouseOut,
           scope: this
      });

Returns:

- `void`

Observable

fireEvent( `String eventName`, `Object... args` ) : Boolean
Fires the specified event with the passed parameters (minus the event name).
Fires the specified event with the passed parameters (minus the event name).
Parameters:

- `eventName` : String
- `args` : Object...
  Variable number of parameters are passed to handlers

Returns:

- `Boolean`
  returns false if any of the handlers return false otherwise it returns true

Observable

getNodeById( `String id` ) : Node
Gets a node in this tree by its id.
Gets a node in this tree by its id.
Parameters:

- `id` : String

Returns:

- `Node`

Tree

getRootNode() : Node
Returns the root node for this tree.
Returns the root node for this tree.
Parameters:

- None.

Returns:

- `Node`

Tree

hasListener( `String eventName` ) : Boolean
Checks to see if this object has any listeners for a specified event
Checks to see if this object has any listeners for a specified event
Parameters:

- `eventName` : String
  The name of the event to check for

Returns:

- `Boolean`
  True if the event is being listened for, else false

Observable

on( `String eventName`, `Function handler`, [`Object scope`], [`Object options`] ) : void
Appends an event handler to this element (shorthand for addListener)
Appends an event handler to this element (shorthand for addListener)
Parameters:

- `eventName` : String
  The type of event to listen for
- `handler` : Function
  The method the event invokes
- `scope` : Object
  (optional) The scope in which to execute the handler function. The handler function's "this" context.
- `options` : Object
  (optional)

Returns:

- `void`

Observable

purgeListeners() : void
Removes all listeners for this object
Removes all listeners for this object
Parameters:

- None.

Returns:

- `void`

Observable

removeListener( `String eventName`, `Function handler`, [`Object scope`] ) : void
Removes a listener
Removes a listener
Parameters:

- `eventName` : String
  The type of event to listen for
- `handler` : Function
  The handler to remove
- `scope` : Object
  (optional) The scope (this object) for the handler

Returns:

- `void`

Observable

resumeEvents() : void
Resume firing events. (see suspendEvents)
Resume firing events. (see suspendEvents)
Parameters:

- None.

Returns:

- `void`

Observable

setRootNode( `Node node` ) : Node
Sets the root node for this tree.
Sets the root node for this tree.
Parameters:

- `node` : Node

Returns:

- `Node`

Tree

suspendEvents() : void
Suspend the firing of all events. (see resumeEvents)
Suspend the firing of all events. (see resumeEvents)
Parameters:

- None.

Returns:

- `void`

Observable

un( `String eventName`, `Function handler`, [`Object scope`] ) : void
Removes a listener (shorthand for removeListener)
Removes a listener (shorthand for removeListener)
Parameters:

- `eventName` : String
  The type of event to listen for
- `handler` : Function
  The handler to remove
- `scope` : Object
  (optional) The scope (this object) for the handler

Returns:

- `void`

Observable

## Public Events

Event | Defined By
--- | ---

append : ( `Tree tree`, `Node parent`, `Node node`, `Number index` )
Fires when a new child node is appended to a node in this tree.
Fires when a new child node is appended to a node in this tree.
Listeners will be called with the following arguments:

- `tree` : Tree
  The owner tree
- `parent` : Node
  The parent node
- `node` : Node
  The newly appended node
- `index` : Number
  The index of the newly appended node

Tree

beforeappend : ( `Tree tree`, `Node parent`, `Node node` )
Fires before a new child is appended to a node in this tree, return false to cancel the append.
Fires before a new child is appended to a node in this tree, return false to cancel the append.
Listeners will be called with the following arguments:

- `tree` : Tree
  The owner tree
- `parent` : Node
  The parent node
- `node` : Node
  The child node to be appended

Tree

beforeinsert : ( `Tree tree`, `Node parent`, `Node node`, `Node refNode` )
Fires before a new child is inserted in a node in this tree, return false to cancel the insert.
Fires before a new child is inserted in a node in this tree, return false to cancel the insert.
Listeners will be called with the following arguments:

- `tree` : Tree
  The owner tree
- `parent` : Node
  The parent node
- `node` : Node
  The child node to be inserted
- `refNode` : Node
  The child node the node is being inserted before

Tree

beforemove : ( `Tree tree`, `Node node`, `Node oldParent`, `Node newParent`, `Number index` )
Fires before a node is moved to a new location in the tree. Return false to cancel the move.
Fires before a node is moved to a new location in the tree. Return false to cancel the move.
Listeners will be called with the following arguments:

- `tree` : Tree
  The owner tree
- `node` : Node
  The node being moved
- `oldParent` : Node
  The parent of the node
- `newParent` : Node
  The new parent the node is moving to
- `index` : Number
  The index it is being moved to

Tree

beforeremove : ( `Tree tree`, `Node parent`, `Node node` )
Fires before a child is removed from a node in this tree, return false to cancel the remove.
Fires before a child is removed from a node in this tree, return false to cancel the remove.
Listeners will be called with the following arguments:

- `tree` : Tree
  The owner tree
- `parent` : Node
  The parent node
- `node` : Node
  The child node to be removed

Tree

insert : ( `Tree tree`, `Node parent`, `Node node`, `Node refNode` )
Fires when a new child node is inserted in a node in this tree.
Fires when a new child node is inserted in a node in this tree.
Listeners will be called with the following arguments:

- `tree` : Tree
  The owner tree
- `parent` : Node
  The parent node
- `node` : Node
  The child node inserted
- `refNode` : Node
  The child node the node was inserted before

Tree

move : ( `Tree tree`, `Node node`, `Node oldParent`, `Node newParent`, `Number index` )
Fires when a node is moved to a new location in the tree
Fires when a node is moved to a new location in the tree
Listeners will be called with the following arguments:

- `tree` : Tree
  The owner tree
- `node` : Node
  The node moved
- `oldParent` : Node
  The old parent of this node
- `newParent` : Node
  The new parent of this node
- `index` : Number
  The index it was moved to

Tree

remove : ( `Tree tree`, `Node parent`, `Node node` )
Fires when a child node is removed from a node in this tree.
Fires when a child node is removed from a node in this tree.
Listeners will be called with the following arguments:

- `tree` : Tree
  The owner tree
- `parent` : Node
  The parent node
- `node` : Node
  The child node removed

Tree